package com.dfsek.feldspar

import android.app.Application
import android.content.Context
import android.util.Log
import com.dfsek.feldspar.AppState.Preferences.updatePrefs
import com.dfsek.feldspar.AppState.amplitudia
import com.dfsek.feldspar.AppState.updateTheme
import com.dfsek.feldspar.util.RoomDisplayNameFallbackProviderImpl
import org.matrix.android.sdk.api.Matrix
import org.matrix.android.sdk.api.MatrixConfiguration

class Feldspar : Application() {
    private lateinit var matrix: Matrix

    override fun onCreate() {
        super.onCreate()
        createMatrix()
        val lastSession = matrix.authenticationService().getLastAuthenticatedSession()
        updateTheme()
        updatePrefs()
        amplitudia()
        if (lastSession != null) {
            Log.i("Session", "Restoring previous session.")
            AppState.startSession(lastSession)
        }
    }
    private fun createMatrix() {
        matrix = Matrix(
            context = this,
            matrixConfiguration = MatrixConfiguration(
                roomDisplayNameFallbackProvider = RoomDisplayNameFallbackProviderImpl
            )
        )
    }

    companion object {
        fun getMatrix(context: Context): Matrix {
            return (context.applicationContext as Feldspar).matrix
        }
    }

}