package com.dfsek.feldspar.state

import com.dfsek.feldspar.AppState
import org.matrix.android.sdk.api.session.Session

class UserState(val client: Session) {
    fun getAvatar(): String? {
        return client.userService()
            .getUser(client.myUserId)
            ?.avatarUrl
    }

    fun getUsername() = client.myUserId

    suspend fun logout() {
        client.signOutService().signOut(true)
        AppState.clearSession()
    }
}